# About this program...

## What is LLXAMP?

LLxamp is a Linux+Apache+PHP+MariaDB instance that can be used to run student practices with the PHP programming language, learn how to configure a web server like Apache, or learn how to use MySQL/MariaDB database management systems.

## Why do I need LLXAMP?

The software contained in Llxamp can also be obtained from the operating system packages, but in some cases it may present problems if this software is already being used for other tasks in the system and you do not want to use the existing installation to perform practices that could leave that configuration without service.

Additionally, a system installation may not be sufficient if multiple users need to access these practices on the same machine since the system installation is unique and requires administrative permissions to modify configuration files.

## LLXAMP Features

 - Allows software installation to run in user mode with the entire installation in the user directory where files can be modified by the student.
 - Allows the use of "virtual hosts" (limited to .local domains) without superuser permissions.
 - Efficient in disk usage, part of the installation is shared by all machine users.
 - Has a graphical interface for starting/stopping/status of servers and modification of important files, as well as a viewer for the logs being generated.
 - Allows SSL access

## How to start using it?

Although this program has multiple command line commands, it is designed to be used from the *"llxamp-gui"* graphical interface that can be launched from the console or from the graphical system's application menu.

The first time it is used by the user, the software is not yet installed in their private user folder *"$HOME"*, it will be necessary to prepare the installation for each user from the only active button presented in the graphical interface. Later, when the installation process is finished, it is possible to use all services and all options will be enabled in the interface.

The installation will be performed in the path *"$HOME/llxamp"* where the user can observe and modify all installation files. There is no danger of breaking anything in the system since this directory could be regenerated by forcing another reinstallation from the graphical interface.

If you want to modify the configuration files, it is not necessary to use a different tool than the Llxamp graphical interface; the configuration files in use by the services can be edited from the upper menus.

On the right side of the interface, there are buttons that allow performing the most common actions such as:

- Start Apache and MariaDB services.
- Stop active services.
- Open the browser to check the default page served by Apache.
- Open the browser to check the page served by Apache using SSL.
- Open the browser with the PhpMyAdmin administration portal to manage the MariaDB DBMS.
- Show TCP ports used in the system.
- Show TCP ports available in the system.
- Make a backup of the data that the user has modified in their installation since it was installed.
- Show a compact summary of the configuration used in the Apache web server.
- Show a compact summary of the configuration used by PHP.

## What is the initial password to access PhpMyAdmin?

The initial installation uses the username "root" and password "root"

## What is the path to access PhpMyAdmin?

To access PhpMyAdmin, it will be necessary to use the path "/phpMyAdmin/index.php" exactly with uppercase/lowercase through the browser.

## Which ports do the services initially use?

Initially, services are started with ports higher than 1024, this is a limitation due to using these services as an unprivileged user.

When services are started, the ports used can be observed at the bottom of the interface, as well as the number of processes that each service has in use.

Initially, the Apache installation will use ports 8080 (non-SSL) and 8443 (SSL).

Initially, the MariaDB installation will use port 13306

## How can I conveniently start serving web pages using the PHP installation?

The default folder for static HTML or PHP content is *"$HOME/llxamp/httpd/htdocs"*, where initially you will find:

- An *index.html* file (It works)
- An *index.php* file (PHP Information)
- A *db.php* file (Shows the tables in the "test" database)

If you don't want to use this folder, it will also be possible to enable the *"user_dir"* module of the Apache service (by uncommenting the corresponding line in the Apache configuration file) and use the "public_html" folder in the user's *"$HOME"*.

## How can I use VirtualHosts?

A limitation when running in user mode is that certain system files cannot be modified, therefore only *.local* domains can be used.

To use them, the corresponding sections must be configured in the Apache configuration file using the desired domain,
For example:

```
<VirtualHost example.local:8080>
    DocumentRoot "/webexample"
    ServerName example.local

    # other directives here
</VirtualHost>
```

## How can I use the MariaDB installation from the command line?

A *"llxamp-mysql"* command is available that abbreviates usage without having to use additional parameters.
